
// Open Source, private use only! 
// Lokadressen melden nach DiMo (Digitale Modellbahn)
// Heft 3-2020
// Autor F. Bollow

// write/read Queue
#define QDIM 64
#define QPMSK QDIM-1
volatile char Queue[QDIM] = {0};
volatile uint16_t WRptr  =  0;
volatile uint16_t RDptr  =  0;

char PathFile[]= {__FILE__};

volatile uint8_t x;
volatile uint8_t d;
volatile bool flag = false;

unsigned long tstart = 0;

void setup()
{
  Serial.begin(19200);
  Serial.print("Arduino Mega, ");
  Serial.println(PathFile+strlen(PathFile)-13);
  //Serial.print(__DATE__); Serial.print(' ');Serial.println(__TIME__);
  //Serial.println(" Empfang aus Queue mit Serial Interrupt");
  Serial.println("      h.mi.se.ms");
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW);
  
  //--configure UART3 of MEGA: Bd = 19200; RXRDY interrupt----
  UCSR3B = 0b10011000;  //
  UCSR3C = 0b00000110;  //
  //-Bd: 19200-------------
  UBRR3L = 0x33;
  UBRR3H = 0x00;
  //--global int enable--
  bitSet(SREG, 7);
  //UDR3 = 0x3A;  // Prompt (nur 1 Zeichen)  
  // UDR3 (direkt) nicht zuverlaessig
}



void loop()
{
//uart3dOut(0x31);  
//uart3dOut(0x32);  
//uart3dOut(0x33);  
delay(200);

uart3dOut(0x20);
//uart3sOut(Frame); 
//uart3dOut(0x20);

tstart = millis();
/*
TimeMSms(millis());
delay(3456); Serial.println();
TimeMSms(millis());
delay(3456); Serial.println();
TimeMSms(millis());
delay(50006); Serial.println();
TimeMSms(millis());
*/

while(1) {  

   fetch();
} 
} // loop()

void TimeMSms(unsigned long All_ms) {
char snutz[40] = {};
All_ms = All_ms - tstart;
uint32_t allsec = All_ms/1000;
uint16_t ms     = All_ms%1000;
uint16_t minut  = allsec/60;
uint16_t sec    = allsec%60;
uint16_t std    = minut/60;
          minut = minut%60;

sprintf(snutz, "%2d",std);   Serial.print(snutz);Serial.print('.');
sprintf(snutz, "%02d",minut); Serial.print(snutz);Serial.print('.');
sprintf(snutz, "%02d",sec);  Serial.print(snutz);Serial.print('.');
sprintf(snutz, "%03d",ms);   Serial.print(snutz);Serial.print(' ');

} // TimeMSms()


void fetch (void) {

  static int lncnt = 0;
  

while (WRptr != RDptr)
  {
    d = Queue[RDptr];
    RDptr++;
    RDptr = RDptr & QPMSK;

    DsplFrame(d);
  } // while
} // fetch()


void DsplFrame(uint8_t dat) {

static uint8_t  Bptr = 0;
static uint8_t  Hadr = 0;
uint16_t        Ladr = 0;

switch (dat) {
case 0xFC: Bptr = 1; 
     break;
case 0xFF: Bptr = 0;
     break;
default:    
     switch (Bptr) {
     case 1: LineManager();
                          
             if (dat < 10) Serial.print(' '); 
             Serial.print(dat);
             Serial.print(": "); 
             Bptr = 2;
             break;
     case 2: Hadr = dat & 0x7F;
             Bptr = 3;
             break;
     case 3: Ladr = (Hadr << 8) + dat;
             switch (Ladr) {
             case 0x7777: Serial.print("Occ.");
                          Bptr = 0;
                          break;
             case 0:      Serial.print("clr.");
                          Bptr = 0;
                          break;
             default:     if (Ladr < 10)       Serial.print("   ");
                          else if (Ladr < 100) Serial.print("  ");
                          else if (Ladr < 1000)Serial.print(" ");
                          Serial.print(Ladr);
                          Bptr = 0;
                          break;              }             
     default:Bptr = 0;
             break;           
     }    
 }
} // DsplFrame()


void LineManager(void) {
static uint16_t SeqCnt = 0;

if (SeqCnt % 5) {
   SeqCnt++;
   Serial.print("  ");
   }
else {
      Serial.println();
      if (SeqCnt < 10)       Serial.print("   ");
      else if (SeqCnt < 100) Serial.print("  ");
      else if (SeqCnt < 1000)Serial.print(" ");
      Serial.print(SeqCnt);  Serial.print(" ");
      SeqCnt++;
      TimeMSms(millis());
    }  
} // LineManager()


ISR(USART3_RX_vect)
{
  //digitalWrite(13, HIGH); //debugging code
  x = UDR3;    //receive from UART3
  //UDR3 = 0x3E;
  Queue[WRptr] = x;
  WRptr++;
  WRptr = WRptr & QPMSK;
  //if (x==0x23) flag = true;
}

void uart3dOut(uint8_t dat) {
// transmitter empty? (data sheet p.191)
while (!(UCSR3A & 0b00100000)) {}
      UDR3 = dat;
}

void uart3sOut(char *s) {
int sp = 0;
// transmitter empty? (data sheet p.191)

while(s[sp]) {

  while (!(UCSR3A & 0b00100000)) {}
      UDR3 = s[sp];
      sp++;
}
} // uart3dOut()
